--- portable/database.pyx.orig	Mon Mar 19 22:01:55 2007
+++ portable/database.pyx	Tue Mar 27 22:46:59 2007
@@ -17,7 +17,6 @@
 
 import config
 
-
 class DatabaseConstraintError(Exception):
     """Raised when a DDBObject fails its constraint checking during
     signalChange().
@@ -45,6 +44,11 @@
 class ObjectNotFoundError(StandardError):
     pass
 
+##
+# Raised when an attempt is made to add an object that already exists
+class ObjectAlreadyExistsError(StandardError):
+    pass
+
 # Raised when an attempt is made to call a function that's only
 # allowed to be called from the root database
 class NotRootDBError(StandardError):
@@ -694,7 +698,8 @@
     def addBeforeCursor(self, newobject,value=NoValue):
         self.confirmDBThread()
         if self.objectLocs.has_key(newobject.id):
-            raise Exception, "%s (%d) is already in the database" % (newobject, newobject.id)
+            msg = "%s (%d) is already in the database" % (newobject, newobject.id)
+            raise ObjectAlreadyExistsError, msg
         point = self.cursor
         if point is None:
             point = self.objects.firstIter().copy()
